import Alpaca from '@alpacahq/alpaca-trade-api'
import { QuoteProvider, Quote } from '../interface/quote';

export class AlpacaQuoteProvider implements QuoteProvider {
    readonly alpaca: Alpaca;

    readonly fetchQuote = (symbol: string): Promise<Quote> => {
        return this.alpaca.getLatestQuote(symbol).then((quote) => {
            return new Quote(
                quote.Symbol,
                quote.AskPrice,
                quote.AskSize,
                quote.BidPrice,
                quote.BidSize,
                new Date(Date.parse(quote.Timestamp))
            );
        }).catch((err) => {
            return err;
        })
    }

    constructor(alpaca: Alpaca) {
        this.alpaca = alpaca;
    }
}
